2010-05-28  Lluis Sanchez Gual  <lluis@novell.com>

	* RemoteSoftDebuggerSession.cs: Fix incorrect use of
	  ShowCustomDialog/RunCustomDialog.

2010-04-29  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerEngine.cs: Track API changes.

2010-04-26  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerEngine.cs: External console processes are now
	  wrapped by a IProcessAsyncOperation interface, instead of a
	  Process instance. In this way it is possible to create
	  external consoles which are not directly bound to a process.

2010-03-30  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerEngine.cs: Fix external console support again.

2010-03-22  Lluis Sanchez Gual  <lluis@novell.com>

	* AssemblyInfo.cs:
	* Manifest.addin.xml: Bumped MD version.

2010-03-17  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* SoftDebuggerEngine.cs:
	* RemoteSoftDebuggerSession.cs:
	* MonoDevelop.Debugger.Soft.csproj: Merged MD.Projects into
	  MD.Core, and MD.Projects.Gui, MD.Core.Gui and MD.Components
	  into MD.Ide.

2010-03-09  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs: Track logging API.

2010-02-16  Lluis Sanchez Gual  <lluis@novell.com>

	* Manifest.addin.xml:
	* SoftDebuggerEngine.cs: Track api changes. Some engine info
	  is now taken from extension node metadata.

2010-02-02  Lluis Sanchez Gual  <lluis@novell.com>

	* RemoteSoftDebuggerSession.cs: Use the new namespace for the
	  soft debugger. Updated the sdb client library.

2010-01-20  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* ArrayAdaptor.cs:
	* SoftDebuggerEngine.cs:
	* SoftDebuggerSession.cs:
	* SoftDebuggerAdaptor.cs:
	* FieldValueReference.cs:
	* Mono.Debugger.Soft.dll:
	* SoftDebuggerBacktrace.cs:
	* SoftEvaluationContext.cs:
	* VariableValueReference.cs:
	* PropertyValueReference.cs:
	* Mono.Debugger.Soft.dll.mdb:
	* RemoteSoftDebuggerSession.cs:
	* MonoDevelop.Debugger.Soft.csproj: Split out a new dll
	  Mono.Debugging.Soft from the soft debugger addin. It has the
	  bits that have with no MD deps apart from Mono.Debugging,
	  and it's strongnamed so MonoVS can use it.

2010-01-19  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerAdaptor.cs: In the log message for failed
	  invokes, include info about the object and method.

2010-01-15  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerAdaptor.cs: Fix the error calling ToString when
	  inspecting structs that don't override it.

2009-12-15  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: Fixed ToString call for structs.
	  Improve casting between primitive types and enums. Add some
	  missing null checks.

	* FieldValueReference.cs: Allow getting struct and primitive
	  value fields.

	* VariableValueReference.cs: Return correct origin flag.

2009-12-14  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Flag 'external' assemblies as such
	  in the log.

2009-12-14  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Ignore VMDisconnectedException when
	  exiting/disposing. Log errors instead of console.writeline.

2009-12-14  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Add an environment variable for
	  enabling sdb logging.

2009-12-14  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs:
	* SoftDebuggerSession.cs:
	* RemoteSoftDebuggerSession.cs: Pass the message along to the
	  debugger log output about missing user assemblies or errors
	  getting assembly name.

2009-12-11  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: Implement TryConvert.

2009-12-10  Geoff Norton  <gnorton@novell.com>

	* RemoteSoftDebuggerSession.cs: Only redirect the output when
	asked to do so.

2009-12-09  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: Hide abstract properties. There is
	  nothing we can do with them.

2009-12-09  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: Convert StructMirrors of type IntPtr
	  to real IntPtr objects.

2009-12-09  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerSession.cs: Add support for external console.

2009-12-07  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugger.Soft.dll:
	* Mono.Debugger.Soft.dll.mdb: Updated.

2009-12-07  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs:
	* RemoteSoftDebuggerSession.cs: Add an OnConnected virtual
	  method that subclasses can use to hook into when the app is
	  successfully started.

2009-12-07  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Pass isError to OnTargetOutput.

2009-12-07  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs:
	* RemoteSoftDebuggerSession.cs: Add a fallback to try to kill
	  hung debugger processes.

2009-12-04  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: When pausing and picking a frame to
	  display, pick one with user code.

2009-12-03  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugger.Soft.dll:
	* Mono.Debugger.Soft.dll.mdb: Updated.

2009-12-03  Lluis Sanchez Gual  <lluis@novell.com>

	* FieldValueReference.cs:
	* SoftDebuggerAdaptor.cs:
	* PropertyValueReference.cs: Allow modifying field values on
	  structs. Track api changes.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugger.Soft.dll: Updated, fixes debugger keeping 
	  socket open after cancellation.
	* Mono.Debugger.Soft.dll.mdb:
	* Makefile.am: Include the debugger mdb file.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Name threads to make debugging
	  easier.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Avoid NREs disposing session that
	  never connected.

2009-12-03  Lluis Sanchez Gual  <lluis@novell.com>

	* FieldValueReference.cs:
	* PropertyValueReference.cs: Don't allow setting field or
	  property values on structs. It is not supported for now.

2009-12-03  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: Properly handle boxed primitive
	  values.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* RemoteSoftDebuggerSession.cs: Revert the previous change, as
	  it's no longer necessary after making the base
	  DebuggerSession terminate the session if Run throws.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* RemoteSoftDebuggerSession.cs: If we get an exception while
	  connecting, kill the session, or it doesn't exit and the
	  thread pads start throwing NREs on a null vm.

2009-12-03  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerSession.cs: Run CancelAsyncOperations in a
	  background thread, since it can block and cause a deadlock
	  with the main session lock. Fixes bug #558273.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Don't show the socket exception
	  that's caused by cancelling the session.

2009-12-02  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs:
	* SoftDebuggerSession.cs: Implemented IsExternalType.

2009-12-02  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: Implement GetBaseType. Hide members
	  that have the CompilerGenerated attribute.

	* FieldValueReference.cs:
	* PropertyValueReference.cs: Implement DeclaringType. Set the
	  correct flags for fields and properties.

2009-12-02  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: Properly handle properties with
	  private accessors.

	* PropertyValueReference.cs: Set the ReadOnly flag if the
	  property is read-only.

2009-11-30  Michael Hutchinson  <mhutchinson@novell.com>

	* PropertyValueReference.cs: Allow getting and setting
	  nonpublic properties.

2009-11-30  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerAdaptor.cs: Don't NRE in
	  MethodCall.WaitForCompleted if it was never invoked, or if
	  there was an exception in Invoke.

2009-11-30  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: Don't call ToString when it doesn't
	  have been overriden.

2009-11-25  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Fix picking a default thread 
	  to position to when pausing. The current_thread value 
	  had been nulled on resume to fix BP queuing, so 
	  introduce a new recent_thread field. Also, make
	  a better attempt to find a non-ended thread if the 
	  recent_thread has ended.

2009-11-25  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: When disabling or removing 
	  breakpoints or catchpoints, flush any queued occurrences of 
	  them on other threads.

2009-11-25  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerSession.cs: Fix potential null ref.

2009-11-24  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs:
	* SoftDebuggerBacktrace.cs: Mark frames that are external
	  code.

2009-11-24  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerBacktrace.cs: Include the type name in the
	  method name. Fixes bug #556941.

2009-11-24  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerEngine.cs:
	* SoftDebuggerSession.cs: Add support for tracepoints and
	  conditional breakpoints.

2009-11-24  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerAdaptor.cs: Track API.
	* Mono.Debugger.Soft.dll: Updated.

2009-11-24  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerSession.cs: The stepping request should always
	  be disabled when stopping for whatever reason.

2009-11-23  Michael Hutchinson  <mhutchinson@novell.com>

	* Manifest.addin.xml: Declare dep on Mono.Debugger.Soft.dll.

2009-11-20  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugger.Soft.dll: Updated.

	* Makefile.am:
	* MonoDevelop.Debugger.Soft.csproj: Ref Cecil.

	* SoftDebuggerEngine.cs:
	* SoftDebuggerSession.cs:
	* RemoteSoftDebuggerSession.cs: Implement support for assembly
	  filters.

2009-11-20  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerEngine.cs: Implement ID member.

2009-11-19  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: In GetMember, look for members in
	  parent types.

2009-11-19  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerSession.cs: Fix disposing code.

2009-11-19  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs: Properly implement
	  MethodCall.Shutdown.

2009-11-19  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs:
	* SoftDebuggerSession.cs:
	* SoftEvaluationContext.cs:
	* SoftDebuggerBacktrace.cs: Track api changes. Moved some code
	  to Mono.Debugging.

2009-11-19  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerAdaptor.cs: Fix race in async eval. We didn't
	  actually need a callback, since we're just wrapping one
	  async API in another.

2009-11-19  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerAdaptor.cs: Make MethodCall class more readable.

2009-11-19  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerAdaptor.cs: Use the async eval API instead of
	  creating a thread.

2009-11-19  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerAdaptor.cs: Fix invocation options.

2009-11-19  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftEvaluationContext.cs: Minor fix.

2009-11-18  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerAdaptor.cs:
	* SoftEvaluationContext.cs:
	* SoftDebuggerBacktrace.cs:
	* PropertyValueReference.cs: Track api changes. Call
	  ToString() to convert objects to values, when that option is
	  enabled.

2009-11-17  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs:
	* SoftDebuggerSession.cs:
	* RemoteSoftDebuggerSession.cs: Use the user modules as
	  assembly filters for stepping, if the startinfo has them (it
	  doesn't yet).

2009-11-17  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Fix the active thread object.

2009-11-17  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerAdaptor.cs: Make invokes single-threaded and
	  ignoring breakpoints.

2009-11-17  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs:
	* RemoteSoftDebuggerSession.cs: Empty the process info cache
	  when we resume, so that the process and thread lists get
	  updated.

2009-11-17  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftEvaluationContext.cs:
	* SoftDebuggerBacktrace.cs: Use the new options object.

	* SoftDebuggerSession.cs: Propagate busy state changes.
	  Dispose the vm in a background thread, to avoid unnecessary
	  waits. Cancel evaluation operations before continuing
	  execution.

	* SoftDebuggerAdaptor.cs: Improve support for
	  AllowTargetInvoke flag. Don't try to abort target invokes.
	  That's not yet supported.

2009-11-17  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugger.Soft.dll: Updated.

	* SoftDebuggerSession.cs: Queue stop events when more than one
	  come in at once, and dequeue them when resuming.

2009-11-13  Michael Hutchinson  <mhutchinson@novell.com>

	* RemoteSoftDebuggerSession.cs: Unify the AppName handling for
	  remote sessions.

2009-11-13  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Refactor to tidy up the main event
	  handler.

2009-11-13  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerSession.cs:
	* SoftEvaluationContext.cs: After an evaluation in the target,
	  the current frame may be invalidated, so it has to be
	  queried again.

	* SoftDebuggerAdaptor.cs: Misc value conversion fixes.

	* VariableValueReference.cs: Implement local variable
	  assignment.

2009-11-13  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerSession.cs: Add missing call to base dispose.

	* RemoteSoftDebuggerSession.cs: Fix warning.

2009-11-13  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerSession.cs: Avoid IDE crash when an exception is
	  thrown in the event handler.

2009-11-12  Geoff Norton  <gnorton@novell.com>

	* RemoteSoftDebuggerSession.cs: Not all Listen() events redirect
	the console as well.

2009-11-12  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Catch exceptions when getting
	  process name. Works around Mono bug with symlinked runtimes.

2009-11-11  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Fix bad state check.

2009-11-11  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs:
	* SoftDebuggerSession.cs:
	* Mono.Debugger.Soft.dll:
	* RemoteSoftDebuggerSession.cs: Use new async launch/listen
	  APIs. Add proper support for parallel runtimes.

2009-11-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am: Fixed bad copy.

2009-11-10  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs: Don't try to parse version number.
	  Instead check for presence of Mono.Debugger.Soft.dll.

2009-11-10  Michael Hutchinson  <mhutchinson@novell.com>

	* RemoteSoftDebuggerSession.cs: Make GetListenMessage virtual
	  instead of abstract.

2009-11-09  Geoff Norton  <gnorton@novell.com>

	* SoftDebuggerSession.cs: Don't handle disconnects or 
	VMDeath, as we will (erroneously) try to resume a dead
	vm

2009-11-09  Michael Hutchinson  <mhutchinson@novell.com>

	* MonoDevelop.Debugger.Soft.csproj: Add makefiles to project
	  files.

	* Makefile.am: Install the Mono.Debugger.Soft assembly.

2009-11-09  Michael Hutchinson  <mhutchinson@novell.com>

	* MonoDevelop.Debugger.Soft.csproj: Don't local-copy project
	  refs.

2009-11-09  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* MonoDevelop.Debugger.Soft.csproj: Wire the soft debug addin
	  into the build.

2009-11-09  Michael Hutchinson  <mhutchinson@novell.com>

	* MonoDevelop.Debugger.Soft.csproj: Moved soft debug addin
	  from extras.

2009-11-09  Lluis Sanchez Gual  <lluis@novell.com>

	* SoftDebuggerSession.cs: Redirect errors. Improve handling of
	  vm disconnection.

2009-11-09  Michael Hutchinson  <mhutchinson@novell.com>

	* MonoDevelop.Debugger.Soft.csproj: Added refs to GTK.

	* SoftDebuggerSession.cs: Remove unneeded option.

	* RemoteSoftDebuggerSession.cs: Abstracted out listening code
	from the iPhone debugger session.

2009-11-07  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs: Stub out support for targetting
	different Mono runtimes. Expose a static CanDebugRuntime
	method.

2009-11-03  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Better handling of the sim process
	  exiting while listen dialog is open.

2009-11-03  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Fix the dispatch dervice deadlock in
	  the debugger start.

2009-11-02  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: In progress.

2009-11-02  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs: Disable for runtime < 2.8

2009-10-30  Lluis Sanchez Gual  <lluis@novell.com>

	* AssemblyInfo.cs:
	* Manifest.addin.xml: Bump MD version.

2009-10-26  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs: Disable sdb for Mono 2.4/2.5/2.6.

2009-10-23  Geoff Norton  <gnorton@novell.com>

	* SoftDebuggerSession.cs: Add a ConnectOutput call that is
	protected for other consumers.
	* Mono.Debugger.dll: Updated

2009-10-23  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Make exiting more robust.

2009-10-23  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs:
	* SoftDebuggerSession.cs: Add preliminary support for
	  catchpoints.

2009-10-22  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugger.dll: Updated.

	* SoftDebuggerSession.cs: Stop at most recent thread when
	  stopping.

2009-10-21  Geoff Norton  <gnorton@novell.com>

	* SoftDebuggerSession.cs: Fix the formatting in the output pad.
	Dont call .Enable() directly as this could result in duplicate
	entries in the target.

2009-10-16  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerSession.cs: Expose some API for subclasses to
	  override.

2009-10-16  Michael Hutchinson  <mhutchinson@novell.com>

	* MonoDevelop.Debugger.Soft.csproj: Don't require specific
	  versions of refs.

2009-10-16  Michael Hutchinson  <mhutchinson@novell.com>

	* SoftDebuggerEngine.cs: Fix spelling of
	  GetAttachableProcesses API.

2009-10-14  Michael Hutchinson  <mhutchinson@novell.com>

	* AssemblyInfo.cs:
	* Manifest.addin.xml: Fixed description.

	* MonoDevelop.Debugger.Soft.csproj: Patch into the extras
	  configure system.

2009-10-05  Lluis Sanchez Gual  <lluis@novell.com>

	* ArrayAdaptor.cs:
	* Mono.Debugger.dll:
	* SoftDebuggerAdaptor.cs:
	* SoftDebuggerSession.cs: Ongoing work.

2009-09-30  Lluis Sanchez Gual  <lluis@novell.com>

	* ArrayAdaptor.cs:
	* SoftDebuggerSession.cs:
	* SoftDebuggerAdaptor.cs: Ongoing work.

